$top:-
%	cputime(T0),
	read(H,[]),
	mincolor(L,N,30,H),
%	cputime(T1),
%	T is T1-T0,
%	write(N),write(' '),write(T),nl,
%	write(L),nl,
	true.

color(L,N):-
	listin(L,1..N),
	graph(L),
	labeling(L,?).

%M is a pessimistic estimate of the number of colors
mincolor(L,N,M,H):-
	listin(L,1..M),
	graph(L),
	between1(N,1,M),	%assumption: between generates from lo to hi
%	write(N), nl,
	write(next),nl,
	listin(L, 1..N),
	labeling(L,H).

labeling(X,H):- labeling(X,0,H).

labeling([],Newup,_).
labeling([X|Y], Up, H):- 
	deleteff(Var, [X|Y], Rest,H),
	labelvar(Var, Up, Newup),
	labeling(Rest, Newup, H).

labelvar(X,N,N):- between(X,1,N).
labelvar(X,N,X):- X is N+1.

between1(X,X,H).
between1(X,L,H):- plus(L,1,L1), H>=L1, between1(X,L1,H).

between(X,L,H):- H >= L, varin(X,L..H), indomain(X).

indomain(X):- domain(X,L), member(X,L).

member(X,[X|_]).
member(X,[_|Y]):- write(*),nl, member(X,Y).

delay listin(nonvar,any).
listin([],_).
listin([X|T],D):- varin(X, D), listin(T,D).

X \= Y :- notplus(X,0,Y).

true.

A,B :- call(A), call(B).

X >= Y :- fail_if(X < Y).

fail_if(X) :- call(X), !, fail.
fail_if(_).
