%Golomb-Lineale (Spektrum der Wissenschaft 2/86,5/86)

$top:-
	enumgol(3,3).

enumgol(N,M):-
	cputime(T0),
	golomb(N,L,M,Len),
	cputime(T1), plus(T0,T,T1),
	write(N),write(' '),write(Len),write(' '),
	write(T),write(' '),write(L),nl,
	N1 is N+1,
	M1 is Len+2*N,
	enumgol(N1,M1).

golomb(N, L, M, Max):-
	L in 0..M,
	Distances in 1..M,
	length(L, N),
%	reorder(L,L1),
	first(L, 0),
	last(L, Max),
	ordered(L),		%constraint to reduce symmetries
	diffs_of_two(L,Distances),
	red(L,Distances),
%	red(N,Distances),
	alldifferent(Distances),
%	N2 is N/2, nth(N2, L, Middle), 2*Middle #=< Max,
	first(Distances,FirstDist),
	last(Distances,LastDist),
	FirstDist #> LastDist,	%constraint to reduce symmetries
	between(Max,1,M),	%assumption: between generates from lo to hi
	labeling(L,[size,constraints]).

%	countdown(M,Len),
%	labelfail(L,Max,T0,Len),
%	!.

labelfail(L,Max,T0,Len):-
	Max #=< Len,
	labeling(L,[size,constraints]),
	cputime(T1), T is T1-T0,
	write(T), write(' '), write(L), nl,
	!,fail.
labelfail(L,_,T0,Len):-
	cputime(T1), plus(T0,T,T1),
	write(T), write(' proof that the last one was the shortest'), nl.

countdown(M,M).
countdown(M,X):- plus(M1,1,M), countdown(M1,X).

diffs_of_two([],[]).
diffs_of_two([H|T],S):- append(S1,S2,S), diffs_of(T,H,S1), diffs_of_two(T,S2).

diffs_of([],_,[]).
diffs_of([H|T],X,[S|ST]):- pluslook(X,S,H), diffs_of(T,X,ST).

red(L,Distances):- 
	length(L, N), 
	plus(N1,2,N), 
	length(L1,N1), 
	append(L1,_,[1,3,6,11,17,25,34,44,55,72,85,106,127,151]),
	append(L1,[1],Ls),
%	write(red(L,Distances,Ls)), nl,
	red(L,Distances,Ls).

red([],[],Ls).
red([H|T],S,Ls):-  append(S1,S2,S), red(T,H,S1,Ls), red(T,S2,Ls).

red([],_,[],_).
red([H|T],X,[D|DT],[M|MT]):-  D#>=M, red(T,X,DT,MT).

ordered([]).
ordered([_]).
ordered([X,Y|T]):- X#<Y, ordered([Y|T]).

between(X,L,H):- H >= L, varin(X,L..H), indomain(X).

%e.g. reorder([1,2,3,4,5,6,7],[4,2,6,1,5,3,7])
reorder([],[]).
reorder(L1,[M|L2]):-
	length(L1,N),
	N2 is N/2,
	length(F,N2),
	append(F, [M|R], L1),
	reorder(F,F1),
	reorder(R,R1),
	interleave(F1,R1,L2).

interleave([],[],[]).
interleave([],[H|T],[H|T]).
interleave([H|T],[],[H|T]).
interleave([X|T1],[Y|T2],[X,Y|T3]):- interleave(T1,T2,T3).

