% 8-queens - what else is there to say

queens(L):-
	safe(L),
	permutation([1,2,3,4,5,6,7,8],L).

permutation(L,[H|T]):-
	delete(H,L,R),
	permutation(R,T).
permutation([],[]).

delete(X,[X|Xs],Xs).
delete(X,[Y|Ys],[Y|Rs]):- delete(X,Ys,Rs).

delay safe(nonvar).
safe([]).
safe([X|Xs]):-
	noattack(X,Xs),
	safe(Xs).

noattack(X,L):- noattack(X,L,1).

delay noattack(any,nonvar,any).
noattack(X,[],Nb).
noattack(X,[Y|Ys],Nb):-
	notsum(X,Nb,Y),
	notsum(Y,Nb,X),
	Nb1 is Nb+1,
	noattack(X,Ys,Nb1).

delay notsum(nonvar,nonvar,nonvar).
notsum(X,Y,Z):- Z is X+Y,!,fail.
notsum(_,_,_).

allq:- queens(L),fail.
allq.

top:-
%	read(L1,[]),
	cputime(T0),
	allq,
	cputime(T1),
	Time is T1-T0,
	write((time=Time)),nl.
