%% !!! incomplete

jobs(
[AA,AB,AC,AD,AE,AF,AG,
BA,BB,
CA,CB,CC,
DA,DB,DC,DD,
AE,EB,
FA,FB,
GA,GB,
HA,HB,HC,HD,HE,HF,HG,HH,
IA,IB,IC,ID,IE,IF,IG,IH]
Msgs,End):-

	task(AA,stim_aa,4,0),
	task(AB,ab,4,1),
	task(AC,ac,2,1),
	task(AD,ad,2,1),
	task(AE,ae,2,3),
	task(AF,af,4,0),
	task(AG,ag,6,2),
	task(BA,stim_ba,2,1),
	task(BB,bb,2,1),
	task(CA,stim_ca,8,0),
	task(CB,cb,14,0),
	task(CC,cc,4,1),
	task(DA,stim_da,2,2),
	task(DB,db,2,2),
	task(DC,dc,2,3),
	task(DD,dd,2,3),
	task(EA,stim_ea,2,3),
	task(EB,eb,2,2),
	task(FA,stim_fa,1,1),
	task(FB,fb,1,1),
	task(GA,stim_ga,1,1),
	task(GB,gb,2,3),
	task(HA,stim_ha,1,7),
	task(HB,hb,1,7),
	task(HC,hc,1,7),
	task(HD,hd,1,7),
	task(HE,he,1,5),
	task(HF,hf,1,5),
	task(HG,hg,1,5),
	task(HH,hh,1,5),
	task(IA,stim_ia,1,4),
	task(IB,ib,1,4),
	task(IC,ic,1,4),
	task(ID,id,1,4),
	task(IE,ie,1,6),
	task(IF,if,1,6),
	task(IG,ig,1,6),
	task(IH,ih,1,6),
	
	period([AA,AB,AC,AD,AE,AF,AG],64,End),
	period([BA,BB],32,End),
	period([CA,CB,CC],32,End),
	period([DA,DB,DC,DD],16,End),
	period([AE,EB],16,End),
	period([FA,FB],32,End),
	period([GA,GB],32,End),
	period([HA,HB,HC,HD,HE,HF,HG,HH],16,End),
	period([IA,IB,IC,ID,IE,IF,IG,IH],16,End),
	
	message(AA,AB,Msgs,Msgs1),
	message(AA,AC,Msgs1,Msgs2),
	message(AB,AD,Msgs2,Msgs3),
	message(AB,AE,Msgs3,Msgs4),
	message(AB,AF,Msgs4,Msgs5),
	message(AC,AD,Msgs5,Msgs6),
	message(AE,AG,Msgs6,Msgs7),
	message(AF,AG,Msgs7,Msgs8),
	message(BA,BB,Msgs8,Msgs9),
	message(CA,CB,Msgs9,Msgs10),
	message(CB,CC,Msgs10,Msgs11),
	message(DA,DB,Msgs11,Msgs12),
	message(DA,DC,Msgs12,Msgs13),
	message(DB,DD,Msgs13,Msgs14),
	message(DC,DD,Msgs14,Msgs15),
	message(EA,EB,Msgs15,Msgs16),
	message(FA,FB,Msgs16,Msgs17),
	message(GA,GB,Msgs17,Msgs18),
	message(HA,HB,Msgs18,Msgs19),
	message(HA,HC,Msgs19,Msgs20),
	message(HB,HD,Msgs20,Msgs21),
	message(HC,HD,Msgs21,Msgs22),
	message(HD,HE,Msgs22,Msgs23),
	message(HE,HF,Msgs23,Msgs24),
	message(HE,HG,Msgs24,Msgs25),
	message(HF,HH,Msgs25,Msgs26),
	message(HG,HH,Msgs26,Msgs27),
	message(IA,IB,Msgs27,Msgs28),
	message(IA,IC,Msgs28,Msgs29),
	message(IB,ID,Msgs29,Msgs30),
	message(IC,ID,Msgs30,Msgs31),
	message(ID,IE,Msgs31,Msgs32),
	message(IE,IF,Msgs32,Msgs33),
	message(IE,IG,Msgs33,Msgs34),
	message(IF,IH,Msgs34,Msgs35),
	message(IG,IH,Msgs35,[]),
	
	alldifferent(Msgs),
	
	mart(AA,AD,62),
	mart(AA,AG,62),
	mart(BA,BB,26),
	mart(CA,CC,58),
	mart(DA,DD,38),
	mart(EA,EB,18),
	mart(FA,FB,18),
	mart(GA,GB,26),
	mart(HA,HH,17),
	mart(IA,IH,17),
	
	true.


task(task(L,Id,Maxt,Comp),Id,Maxt,Comp):- L in 0..127.

period([],_,_).
period([task(L,_,_,_)|T],P,End):-
	times(P,N,End),
	length(L,N),
	periodic(L,P),
	period(T,P,End).

periodic([H|T],P):- periodic(T,H,P).

periodic([],_,_).
periodic([H|T],X,P):- X+P#=H, periodic(T,H,P).

mart(task([H1|_],_,_,_),task([H2|T],_,Maxt2,_),Mart):-
	H2+Maxt2 #=< H1+Mart.

message(task(T1, M, D1), task(T2, M, D2), MsgLst, MsgLst) :-
	!,
	T2 #>= T1 + D1.

message(task(T1, M1, D1), task(T2, M2, D2), [Msg|MsgLst], MsgLst) :-
	M1 \= M2,
	T2 #> T1 + D1,
	[Msg] in 0 .. 15,
	Msg #>= T1 + D1,
	Msg + 1 #=< T2.

sched(Tasks,Messages,End):-
	Messages in 0..127,
	jobs(Tasks,Messages,End),
	constraints(Tasks,Messages),
	choices(Tasks,Messages).


disjoint([]).
disjoint([H|T]) :-
	disjoint(T, H),
	disjoint(T).

disjoint([], _).
disjoint([F|R], X) :-
	same_comp(F, X),
	disjoint(R, X).

same_comp(task(T1, M, D1), task(T2, M, D2)) :-
	!,
	disjoint(T1, D1, T2, D2).
same_comp(task(T1, M1, D1), task(T2, M2, D2)) :-
	M1 \= M2.

choices(Tasks,Messages,End):-
	taskvars(Tasks, TaskVars),
	append(TaskVars, Messages, Vars),
	[End] in 0 .. N,
	disj(Tasks),
	labeling(Vars, [size, constraints]),
	$printdelays, !.
%	writelist(TaskVars),
%	writelist(Messages).

taskvars([], []).
taskvars([task(V, _, _)|RT], [V|RV]) :-
	taskvars(RT, RV).

writelist([]) :-
	write('-->'), read(_, []).

writelist([F|R]) :-
	domain(F, D),
	write(F), write(' in '), write(D), nl,
	writelist(R).


disj([]).
disj([H|T]) :-
	disj(T, H),
	disj(T).

disj([], _).
disj([F|R], X) :-
	disjunctive(F, X),
	disj(R, X).

disjunctive(task(T1,M1,D1), task(T2,M2,D2)):-
	M1 \= M2, !.
disjunctive(task(T1,M,D1), task(T2,M,D2)):-
	T1 #>= T2+D2.
disjunctive(task(T1,M1,D1), task(T2,M2,D2)):-
	T2 #>= T1+D1.

