% 8-queens - what else is there to say

queens(N,L):-
	length(L,N),
	inlist(L,1..N),
	safe(L),
	labeling(L).

delay length(nonvar,any).
delay length(any,nonvar).
length([],0).
length([X|Y],N):- less(0,N), plus(N1,1,N), length(Y,N1).

delay less(nonvar,nonvar).
less(X,Y):- X<Y.

inlist([],_).
inlist([X|Y],D):- X in D, inlist(Y,D).

labeling([]).
labeling([F|T]):- deleteff(X,[F|T],Ls), indomain(X), labeling(Ls).

indomain(X):- domain(X,L), member(X,L).

member(X,[X|_]).
member(X,[_|Y]):- member(X,Y).

%delay safe(nonvar).
safe([]).
safe([X|Xs]):-
	noattack(X,Xs),
	safe(Xs).

noattack(X,L):- noattack(X,L,1).

%delay noattack(any,nonvar,any).
noattack(X,[],Nb).
noattack(X,[Y|Ys],Nb):-
	notplus(X, 0, Y),
	notplus(X,Nb,Y),
	notplus(Y,Nb,X),
	Nb1 is Nb+1,
	noattack(X,Ys,Nb1).

%% delay noteq(nonvar,any).
%% delay noteq(any,nonvar).
%% noteq(X,Y):- notplus(X,0,Y).
%% 
%% delay notsum(any,nonvar,nonvar).
%% delay notsum(nonvar,any,nonvar).
%% delay notsum(nonvar,nonvar,any).
%% notsum(X,Y,Z):- notplus(X,Y,Z).

allq(N) :- queens(N, L), write(*), fail.
allq(N).

oneq(N) :- queens(N, L).

top:-
	read(N, []),
%	cputime(T0),
	allq(N).
%	cputime(T1),
%	Time is 20 * (T1-T0),
%	write((time=Time, queens(N,L))),nl.
